/*
   All emon_widgets code is released under the GNU General Public License v3.
   See COPYRIGHT.txt and LICENSE.txt.

    ---------------------------------------------------------------------
    Part of the OpenEnergyMonitor project:
    http://openenergymonitor.org

    Author: Trystan Lea: trystan.lea@googlemail.com
    If you have any questions please get in touch, try the forums here:
    http://openenergymonitor.org/emon/forum
 */

function feedmultitext_widgetlist()
{
  var widgets = {
    "feedmultitext": 
    {
      "offsetx":-40,"offsety":-30,"width":80,"height":120,
      "menu":"Widgets",
      "options":["alarmstate","armstate","homestate","sosstate","smokestate","tempstate","ploca1"],
      "optionstype":["feed","feed","feed","feed","feed","feed","value"],
      "optionsname":[_Tr("Alarm"),_Tr("Alarm"),_Tr("HOME"),_Tr("SOS"),_Tr("Smoke"),_Tr("Temp"),_Tr("On click")],
      "optionshint":[_Tr("Trigger"),_Tr("Arm/Disarm"),_Tr("Presence"),_Tr("Call"),_Tr("Sensor"),_Tr("> 50C alarm"),_Tr("link Dashboard")] 
    }
  }
  return widgets;
}

function feedmultitext_init()
{
  feedmultitext_draw();
}

function feedmultitext_draw()
{
  $('.feedmultitext').each(function(index)
  {
    var alarmstate = $(this).attr("alarmstate");
    if (alarmstate==undefined) alarmstate = $(this).attr("feed");
    var val_alarmstate = assoc[alarmstate];
    if (val_alarmstate==undefined) val_alarmstate = 0;

    var armstate = $(this).attr("armstate");
    if (armstate==undefined) armstate = $(this).attr("feed");
    var val_armstate = assoc[armstate];
    if (val_armstate==undefined) val_armstate = 0;
    
    var homestate = $(this).attr("homestate");
    if (homestate==undefined) homestate = $(this).attr("feed");
    var val_homestate = assoc[homestate];
    if (val_homestate==undefined) val_homestate = 0;
    
    var sosstate = $(this).attr("sosstate");
    if (sosstate==undefined) sosstate = $(this).attr("feed");
    var val_sosstate = assoc[sosstate];
    if (val_sosstate==undefined) val_sosstate = 0;
 
    var smokestate = $(this).attr("smokestate");
    if (smokestate==undefined) smokestate = $(this).attr("feed");
    var val_smokestate = assoc[smokestate];
    if (val_smokestate==undefined) val_smokestate = 0;

    var tempstate = $(this).attr("tempstate");
    if (tempstate==undefined) tempstate = $(this).attr("feed");
    var val_tempstate = assoc[tempstate];
    if (val_tempstate==undefined) val_tempstate = 0;
   
    var ploca1 = $(this).attr("ploca1");
    if (ploca1==undefined) ploca1 = 0;

    
    
    
    snd = '';
    
    var colorg = "rgb(50,200,50)";  //zelena
    var colorr = "rgb(255,102,102)";  // crvena
    var colorw = "rgb(255, 255, 255)";  // bjela
    
    
    var htmlprefix = "";
    var htmlsufix = ""; 
    var alprefix="[";
    var alsufix="]";
    var disprefix=".";
    var dissufix=".";
    
    var textout = "";
    
    var state_green = false;
    var state_orange = false;
    var state_red = false;
    
    
    
       
    if (val_armstate == 0 && val_homestate == 0 && val_alarmstate == 0 && val_sosstate == 0 && val_smokestate == 0 && val_tempstate == 0){
      textout ="_";
    }
    
    if (val_armstate == 1) {     
       htmlprefix = alprefix;     // alarm arm
       htmlsufix = alsufix;
       textout = "A";
       state_green = true;
    } else {
       htmlprefix = disprefix;
       htmlsufix = dissufix;
    }
    
    if (val_homestate == 1){
       textout = "Z";
       state_orange = true;
    }
    
    if (val_alarmstate == 1){
       textout = "A";
       state_red = true;
    }
    
    if (val_sosstate == 2){
       textout += "S";
       state_red = true;
    }  
    
    if (val_smokestate == 1){
       textout += "P";
       state_red = true;
    } 
    
    if (val_tempstate == 1){
       textout += "T";
       state_red = true;
    }
  
    var interval1 ;
    var interval2 ;
    var interval3 ;
    
    clearInterval(interval1) ;
    clearInterval(interval2) ;
    clearInterval(interval3) ;
    
    textout1= "<span class ='greenm1_noblink' style='text-align: center; font-family:verdana; font-size:15px; font-weight:bold; color:green; cursor:pointer'> "+htmlprefix+textout+htmlsufix+" </span>";
    
    
    if (state_green==true) {
       interval1 = setInterval(blinkermgreen1, 3000); //Runs every second
       textout1= "<span class ='blinkm1_green' style='text-align: center; font-family:verdana; font-size:15px; font-weight:bold; color:white; background-color:green; cursor:pointer'> "+htmlprefix+textout+htmlsufix+" </span>";
    }

    if (state_orange==true) {
       interval2 = setInterval(blinkermorange1, 3000); //Runs every second
       textout1 = "<span class ='blinkm1_orange' style='color:white; background-color:orange; cursor:pointer'> "+htmlprefix+textout+htmlsufix+" </span>";
    }
              
     
    if (state_red==true) {
       snd = new Audio("/obv/Modules/dashboard/Views/js/sound/beep-08b.mp3");
       interval3 = setInterval(blinkermred1, 1000); //Runs every second
       textout1 = "<span class ='blinkm1_red' style=' text-align: center; font-family:verdana; font-size:15px; font-weight:bold; color:white; background-color:red; cursor:pointer '> "+htmlprefix+textout+htmlsufix+" </span> ";
    } 
    

     
 
    
 
     $(this).click(function() {
       snd = '';
       window.location.href = 'http://emon-bns.com/obv/dashboard/view?id='+$(this).attr("ploca1");
       
     });


     $(this).html(textout1); 
  
     
    
  });
}



function feedmultitext_slowupdate()
{
  feedmultitext_draw();
}

function feedmultitext_fastupdate()
{
}

function blinkermgreen1()
{
$('.blinkm1_green').fadeOut(1500);
$('.blinkm1_green').fadeIn(1500);
}

function blinkermred1()
{
   snd.play();
   $('.blinkm1_red').fadeOut(500);
   $('.blinkm1_red').fadeIn(500);
}

function blinkermorange1()
{
   $('.blinkm1_orange').fadeOut(1500);
   $('.blinkm1_orange').fadeIn(1500);
}
