<?php

class MysqlTimeSeries
{

  private $mysqli;

  /**
   * Constructor.
   *
   * @param api $mysqli Instance of mysqli
   *
   * @api
  */
  public function __construct($mysqli)
  {
    $this->mysqli = $mysqli;
  }
  
  /**
   * Creates a histogram type mysql table.
   *
   * @param integer $feedid The feedid of the histogram table to be created
  */
  public function create($feedid)
  {
    $feedname = "feed_".trim($feedid)."";
    
    $result = $this->mysqli->query(
    "CREATE TABLE $feedname (
  time INT UNSIGNED, data float,
    INDEX ( `time` )) ENGINE=MYISAM");
  }
  
  public function insert($feedid,$time,$value)
  {
    $feedname = "feed_".trim($feedid)."";
    $this->mysqli->query("INSERT INTO $feedname (`time`,`data`) VALUES ('$time','$value')");
  }
  
  public function update($feedid,$time,$value)
  {
    $feedname = "feed_".trim($feedid)."";
    // a. update or insert data value in feed table
    $result = $this->mysqli->query("SELECT * FROM $feedname WHERE time = '$time'");

    if (!$result) return $value;
    $row = $result->fetch_array();
    
    if ($row) $this->mysqli->query("UPDATE $feedname SET data = '$value' WHERE time = '$time'");
    if (!$row) {$value = 0; $this->mysqli->query("INSERT INTO $feedname (`time`,`data`) VALUES ('$time','$value')");}
    
    return $value;
  }
  
  // bns funkcija
  public function insert_alarm($feedid,$time,$value,$real_userid)
  {
    $feedname = "feed_".trim($feedid)."";
    $this->mysqli->query("INSERT INTO $feedname (`time`,`data`,`userid`) VALUES ('$time','$value','$real_userid')");
  }
  
  
  
  public function get_data($feedid,$start,$end,$dp)
  {
    //echo $feedid;
    $dp = intval($dp);
    $feedid = intval($feedid);
    $start = floatval($start);
    $end = floatval($end);

    if ($end == 0) $end = time()*1000;

    $feedname = "feed_".trim($feedid)."";
    $start = $start/1000; $end = $end/1000;

    $data = array();
    $range = $end - $start;
    if ($range > 180000 && $dp > 0) // 50 hours
    {
      $td = $range / $dp;
      $stmt = $this->mysqli->prepare("SELECT time, data FROM $feedname WHERE time BETWEEN ? AND ? LIMIT 1");
      $t = $start; $tb = 0;
      $stmt->bind_param("ii", $t, $tb);
      $stmt->bind_result($dataTime, $dataValue);
      for ($i=0; $i<$dp; $i++)
      {
        $tb = $start + intval(($i+1)*$td);
        $stmt->execute();
        if ($stmt->fetch()) {
          if ($dataValue!=NULL) { // Remove this to show white space gaps in graph      
            $time = $dataTime * 1000;
            $data[] = array($time, $dataValue);
            
          }
        }
        $t = $tb;
      }
    } else {
      if ($range > 5000 && $dp > 0)
      {
        $td = intval($range / $dp);
        $sql = "SELECT FLOOR(time/$td) AS time, AVG(data) AS data".
          " FROM $feedname WHERE time BETWEEN $start AND $end".
          " GROUP BY 1";
      } else {
        $td = 1;
        $sql = "SELECT time, data FROM $feedname".
          " WHERE time BETWEEN $start AND $end ORDER BY time DESC";
      }
     
      $result = $this->mysqli->query($sql);
      if($result) {
        while($row = $result->fetch_array()) {
          $dataValue = $row['data'];
          if ($dataValue!=NULL) { // Remove this to show white space gaps in graph      
            $time = $row['time'] * 1000 * $td;  
            $data[] = array($time , $dataValue); 
            
          }
        }
      }
    }

    return $data;
  }
  
  
  
  public function get_datatable($feedid,$start,$end,$kolona)
  {
    global $timeeuoffset;
    
    $kolona = intval($kolona);
    $feedid = intval($feedid);
    $start = floatval($start);
    $end = floatval($end);

    if ($end == 0) $end = time()*1000;

    $feedname = "feed_".trim($feedid)."";
    
    
      
    $start = ($start/1000)-$timeeuoffset;  // a -7200 je europsko ljetno vrijeme
    $end = ($end/1000)-$timeeuoffset;
    $data = array();
      if($kolona==1)
      {
          $sql = "SELECT time, data FROM $feedname".      " WHERE time BETWEEN $start AND $end ORDER BY time ASC";
      } else {
          $sql = "SELECT time, data, data3, data4 FROM $feedname".      " WHERE time BETWEEN $start AND $end ORDER BY time ASC";
      }
      
      $result = $this->mysqli->query($sql);
      if($result) {
        while($row = $result->fetch_object()) {
          $dataValue = $row->data;
          $row->time = gmdate("Y-m-d H:i:s", $row->time);
          //$row->time = gmdate("d.m.Y", $row->time);  // krivo sortira
          $row->data = round($row->data,1);
          if($kolona==2)
          {
            $row->data3 = round($row->data3,1);
            $row->data4 = round($row->data4,1);
          }
          
          if ($dataValue!=NULL) { // Remove this to show white space gaps in graph      
            //$time = $row['time']*1000;
            if($kolona==2) {
              $data[] = $row;  
              //$data[] = array($time , $dataValue, $dataValue3, $dataValue4);
            } else { 
              $data[] = $row;
              //$data[] = array($time , $dataValue);
            }
          }
        }
      }
    return $data;
  }
  
public function get_data_za_excel($feedid,$start,$end,$kolona)
  {
    global $timeeuoffset;
    
    $kolona = intval($kolona);
    $feedid = intval($feedid);
    $start = floatval($start);
    $end = floatval($end);

    if ($end == 0) $end = time()*1000;

    $feedname = "feed_".trim($feedid)."";
    
      
    $start = ($start/1000)-$timeeuoffset;   //  -7200 2h Europsko ljetno  vrijeme 
    $end = ($end/1000)+(24*3600)-$timeeuoffset;  // -7200 2h Europsko ljetno vrijeme
    $data = array();
      if($kolona==1)
      {
          $sql = "SELECT time, data FROM $feedname".      " WHERE time BETWEEN $start AND $end ORDER BY time ASC";
      } else {
          $sql = "SELECT time, data, data3, data4 FROM $feedname".      " WHERE time BETWEEN $start AND $end ORDER BY time ASC";
      }
      
      $result = $this->mysqli->query($sql);
      if($result) {
        while($row = $result->fetch_array()) {
          $dataValue = $row['data'];
          if($kolona==2)
          {
            $dataValue3 = $row['data3'];
            $dataValue4 = $row['data4'];
          }
          
          if ($dataValue!=NULL) { // Remove this to show white space gaps in graph      
            $time = $row['time']*1000;
            if($kolona==2) {
              $data[] = array($time , $dataValue, $dataValue3, $dataValue4);
            } else { 
              $data[] = array($time , $dataValue);
            }
          }
        }
      }
    return $data;
  }

  
  public function export($feedid,$start)
  {
      // Feed id and start time of feed to export
      $feedid = intval($feedid);
      $start = intval($start);

      // Open database etc here
      // Extend timeout limit from 30s to 2mins
      set_time_limit (120);

      // Regulate mysql and apache load.
      $block_size = 400;
      $sleep = 80000;

      $feedname = "feed_".trim($feedid)."";
      $fileName = $feedname.'.csv';

      // There is no need for the browser to cache the output
      header("Cache-Control: no-cache, no-store, must-revalidate");

      // Tell the browser to handle output as a csv file to be downloaded
      header('Content-Description: File Transfer');
      header("Content-type: text/csv");
      header("Content-Disposition: attachment; filename={$fileName}");

      header("Expires: 0");
      header("Pragma: no-cache");

      // Write to output stream
      $fh = @fopen( 'php://output', 'w' );

      // Load new feed blocks until there is no more data 
      $moredata_available = 1;
      while ($moredata_available)
      {
          // 1) Load a block
          $result = $this->mysqli->query("SELECT * FROM $feedname WHERE time>$start  
          ORDER BY time Asc Limit $block_size");

          $moredata_available = 0;
          while($row = $result->fetch_array()) 
          {
            
              // Write block as csv to output stream
              if (!isset($row['data2'])) {
                fputcsv($fh, array($row['time'],$row['data']));
              } else {
                fputcsv($fh, array($row['time'],$row['data'],$row['data2']));
              }

              // Set new start time so that we read the next block along
              $start = $row['time'];
              $moredata_available = 1;
          }
          // 2) Sleep for a bit
          usleep($sleep);
      }

      fclose($fh);
      exit;
  }
  
  public function delete_data_point($feedid,$time)
  {
    $feedid = intval($feedid);
    $time = intval($time);

    $feedname = "feed_".trim($feedid)."";
    $this->mysqli->query("DELETE FROM $feedname where `time` = '$time' LIMIT 1");
  }

  public function deletedatarange($feedid,$start,$end)
  {
    $feedid = intval($feedid);
    $start = intval($start/1000.0);
    $end = intval($end/1000.0);

    $feedname = "feed_".trim($feedid)."";
    $this->mysqli->query("DELETE FROM $feedname where `time` >= '$start' AND `time`<= '$end'");

    return true;
  }
  
  public function delete($feedid)
  {
    $this->mysqli->query("DROP TABLE feed_".$feedid);
  }
  
  public function get_feed_size($feedid)
  {  
    $feedname = "feed_".$feedid;
    $result = $this->mysqli->query("SHOW TABLE STATUS LIKE '$feedname'");
    $row = $result->fetch_array();
    $tablesize = $row['Data_length']+$row['Index_length'];
    return $tablesize;
  }
  
}